## シェルのヒストリをnode-lindaから受信し、hueを操作して雰囲気を伝える

require 'linda-socket.io-client'
require 'hue'

hue = Hue::Client.new
light = hue.lights.find{|light| light.name =~ /居間/ }
light.saturation = 120

linda = Linda::SocketIO::Client.connect 'https://webdbpress-83.herokuapp.com'

## 自分の名前をTupleSpace名にする
ts = linda.tuplespace('YOUR-NAME')

linda.io.on :connect do
  puts "connect!! #{linda.url}/#{ts.name}"

  ts.watch type: "shell" do |err, tuple|
    p tuple
    case tuple.data.cmd
    when "git"
      # 色を変えて、明るくする
      light.hue = (light.hue + 10000) % 65536
      light.brightness = 255
    else
      # 少し明るくする
      light.brightness = [255, light.brightness + 10].min
    end
    puts "h:#{light.hue} s:#{light.saturation} b:#{light.brightness}"
  end

end

loop do
  ## 1分ごとに暗くする
  light.brightness = [160, light.brightness - 2].max
  sleep 60
end
