## シェルのヒストリをnode-lindaに送る（bash版）

require 'linda-socket.io-client'

linda = Linda::SocketIO::Client.connect 'https://webdbpress-83.herokuapp.com'

## 自分の名前をTupleSpace名にする
ts = linda.tuplespace('YOUR-NAME')

linda.io.on :connect do
  puts "connect!! #{linda.url}/#{ts.name}"
end

## shellのヒストリを追う
IO.popen "tail -F #{ENV['HOME']}/.bash_history" do |io|
  while cmd = io.gets.strip
    next if cmd.empty?
    puts cmd
    tuple = {type: "shell", who: ENV['USER']}
    if cmd =~ /git (commit|push|merge)/
      tuple[:cmd] = "git"
    end
    ts.write tuple  # タプルスペースに書き込む
  end
end
