## shellのヒストリをnode-lindaに送信する（zsh版）

require 'linda-socket.io-client'

linda = Linda::SocketIO::Client.connect 'https://webdbpress-83.herokuapp.com'

## 自分の名前をTupleSpace名にする
ts = linda.tuplespace('YOUR-NAME')

linda.io.on :connect do
  puts "connect!! #{linda.url}/#{ts.name}"
end

## shellのヒストリを追う
last_timestamp = 0
IO.popen "tail -F #{ENV['HOME']}/.zsh_history" do |io|
  while line = io.gets.strip
    next if line.empty?
    begin
      timestamp, cmd = line.scan(/^: (\d+):\d+;(.+)$/)[0]
      timestamp = timestamp.to_i

      ## 古いログが流れてくる事があるので除外
      next unless timestamp > last_timestamp

      last_timestamp = timestamp
      puts cmd
      tuple = {type: "shell", who: ENV['USER']}
      if cmd =~ /git (commit|push|merge)/
        tuple[:cmd] = "git"
      end
      ts.write tuple
    rescue => e
      next
    end
  end
end
